std::map< std::string, std::vector<float> > data;

FILE *fp = fopen( path.c_str(), "rb" );
if ( fp == NULL )
{
    printf( "Cuboids::readFromFile failed, when opening %s\n", path.c_str() );
    return EXIT_FAILURE;
}

// (1) read cuboids
// read number of cuboids
read_count = fread( &cuboid_count, sizeof(int), 1, fp );
if ( (cuboid_count < 1) || (read_count != 1) )
{
    std::cerr << "Cuboids::readFromfile failed, count < 1 || read_count != 1..." << cuboid_count << ", " << read_count << std::endl;
    if ( fp )  fclose( fp );

    return EXIT_FAILURE;
}
// allocate
//corners = new float[ cuboid_count * 8 * 3 ];
data["boxes"].resize( cuboid_count * data_lengths.at("boxes"), 0.f );

read_count = fread( data["boxes"].data(), sizeof(float), cuboid_count * 8 * 3, fp );
if ( read_count != cuboid_count * 8 * 3 )
{
    std::cerr << "[" << __func__ << "]: " << " read corners could not read " << cuboid_count * 8 * 3 << " corners\n";
    return EXIT_FAILURE;
}

for ( int cuboid_id = 0; cuboid_id < cuboid_count; ++cuboid_id )
{
    std::vector<float> corner_coords( 24 );
    corner_coords.assign( data["boxes"].begin() +  cuboid_id   * 24,
                          data["boxes"].begin() + (cuboid_id+1)* 24 );
    // ...
}
